# Class MenuItem

java.lang.Object
org.eclipse.swt.widgets.Widget
org.eclipse.swt.widgets.Item
org.eclipse.swt.widgets.MenuItem

All Implemented Interfaces:
  `Adaptable`

public class MenuItem extends Item
Instances of this class represent a selectable user interface object that issues notification when pressed and released.

Styles:
  CHECK, CASCADE, PUSH, RADIO, SEPARATOR
Events:
  Arm, Help, Selection

Note: Only one of the styles CHECK, CASCADE, PUSH, RADIO and SEPARATOR may be specified.

IMPORTANT: This class is not intended to be subclassed.

## Constructor Summary

Constructors
Constructor
Description
`MenuItem(Menu parent, int style)`
Constructs a new instance of this class given its parent (which must be a `Menu`) and a style value describing its behavior and appearance.
`MenuItem(Menu parent, int style, int index)`
Constructs a new instance of this class given its parent (which must be a `Menu`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

## Method Summary

Modifier and Type
Method
Description
`void`
`addArmListener(ArmListener listener)`
Adds the listener to the collection of listeners who will be notified when the arm events are generated for the control, by sending it one of the messages defined in the `ArmListener` interface.
`void`
`addHelpListener(HelpListener listener)`
Adds the listener to the collection of listeners who will be notified when the help events are generated for the control, by sending it one of the messages defined in the `HelpListener` interface.
`void`
`addSelectionListener(SelectionListener listener)`
Adds the listener to the collection of listeners who will be notified when the menu item is selected, by sending it one of the messages defined in the `SelectionListener` interface.
`int`
`getAccelerator()`
Returns the widget accelerator.
`<T> T`
`getAdapter(Class<T> adapter)`
Implementation of the `Adaptable` interface.
`boolean`
`getEnabled()`
Returns `true` if the receiver is enabled, and `false` otherwise.
`int`
`getID()`
Gets the identifier associated with the receiver.
`Menu`
`getMenu()`
Returns the receiver's cascade menu if it has one or null if it does not.
`Menu`
`getParent()`
Returns the receiver's parent, which must be a `Menu`.
`boolean`
`getSelection()`
Returns `true` if the receiver is selected, and false otherwise.
`String`
`getToolTipText()`
Returns the receiver's tool tip text, or null if it has not been set.
`boolean`
`isEnabled()`
Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise.
`void`
`removeArmListener(ArmListener listener)`
Removes the listener from the collection of listeners who will be notified when the arm events are generated for the control.
`void`
`removeHelpListener(HelpListener listener)`
Removes the listener from the collection of listeners who will be notified when the help events are generated for the control.
`void`
`removeSelectionListener(SelectionListener listener)`
Removes the listener from the collection of listeners who will be notified when the control is selected.
`void`
`setAccelerator(int accelerator)`
Sets the widget accelerator.
`void`
`setEnabled(boolean enabled)`
Enables the receiver if the argument is `true`, and disables it otherwise.
`void`
`setID(int id)`
Sets the identifier associated with the receiver to the argument.
`void`
`setImage(Image image)`
Sets the image the receiver will display to the argument.
`void`
`setMenu(Menu menu)`
Sets the receiver's pull down menu to the argument.
`void`
`setSelection(boolean selection)`
Sets the selection state of the receiver.
`void`
`setToolTipText(String toolTipText)`
Sets the receiver's tool tip text to the argument, which may be null indicating that no tool tip text should be shown.

### Methods inherited from class Item

`getImage, getText, setText`

### Methods inherited from class Widget

`addDisposeListener, addListener, addTypedListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, getStyle, getTypedListeners, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, removeTypedListener, reskin, setData, setData, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### MenuItem

public MenuItem(Menu parent, int style)
Constructs a new instance of this class given its parent (which must be a `Menu`) and a style value describing its behavior and appearance. The item is added to the end of the items maintained by its parent.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a menu control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  - `SWT.CHECK`
  - `SWT.CASCADE`
  - `SWT.PUSH`
  - `SWT.RADIO`
  - `SWT.SEPARATOR`
  - `Widget.checkSubclass()`
  - `Widget.getStyle()`

### MenuItem

public MenuItem(Menu parent, int style, int index)
Constructs a new instance of this class given its parent (which must be a `Menu`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a menu control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
  `index` - the zero-relative index to store the receiver in its parent
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the parent (inclusive)
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  - `SWT.CHECK`
  - `SWT.CASCADE`
  - `SWT.PUSH`
  - `SWT.RADIO`
  - `SWT.SEPARATOR`
  - `Widget.checkSubclass()`
  - `Widget.getStyle()`

## Method Details

### getParent

public Menu getParent()
Returns the receiver's parent, which must be a `Menu`.

Returns:
  the receiver's parent
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMenu

public void setMenu(Menu menu)
Sets the receiver's pull down menu to the argument. Only `CASCADE` menu items can have a pull down menu. The sequence of key strokes, button presses and/or button releases that are used to request a pull down menu is platform specific.

Note: Disposing of a menu item that has a pull down menu will dispose of the menu. To avoid this behavior, set the menu to null before the menu item is disposed.

Parameters:
  `menu` - the new pull down menu
Throws:
  `IllegalArgumentException` -
  - ERROR_MENU_NOT_DROP_DOWN - if the menu is not a drop down menu
  - ERROR_MENUITEM_NOT_CASCADE - if the menu item is not a `CASCADE`
  - ERROR_INVALID_ARGUMENT - if the menu has been disposed
  - ERROR_INVALID_PARENT - if the menu is not in the same widget tree
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getMenu

public Menu getMenu()
Returns the receiver's cascade menu if it has one or null if it does not. Only `CASCADE` menu items can have a pull down menu. The sequence of key strokes, button presses and/or button releases that are used to request a pull down menu is platform specific.

Returns:
  the receiver's menu
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setID

public void setID(int id)
Sets the identifier associated with the receiver to the argument.

Parameters:
  `id` - the new identifier. This must be a non-negative value. System-defined identifiers are negative values.
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  - ERROR_INVALID_ARGUMENT - if called with an negative-valued argument.
Since:
  1.4

### getID

public int getID()
Gets the identifier associated with the receiver.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  1.4

### setImage

public void setImage(Image image)
Sets the image the receiver will display to the argument.

Note: This operation is a hint and is not supported on platforms that do not have this concept (for example, Windows NT).

Overrides:
  `setImage` in class `Item`
Parameters:
  `image` - the image to display
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setToolTipText

public void setToolTipText(String toolTipText)
Sets the receiver's tool tip text to the argument, which may be null indicating that no tool tip text should be shown.

Parameters:
  `toolTipText` - the new tool tip text (or null)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.22

### getToolTipText

public String getToolTipText()
Returns the receiver's tool tip text, or null if it has not been set.

Returns:
  the receiver's tool tip text
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.22

### setAccelerator

public void setAccelerator(int accelerator)
Sets the widget accelerator. An accelerator is the bit-wise OR of zero or more modifier masks and a key. Examples: `SWT.MOD1 | SWT.MOD2 | 'T', SWT.MOD3 | SWT.F2`. `SWT.CONTROL | SWT.SHIFT | 'T', SWT.ALT | SWT.F2`. The default value is zero, indicating that the menu item does not have an accelerator.

Parameters:
  `accelerator` - an integer that is the bit-wise OR of masks and a key

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  2.1

- ### getAccelerator

  public int getAccelerator()
  Returns the widget accelerator. An accelerator is the bit-wise OR of zero or more modifier masks and a key. Examples: `SWT.CONTROL | SWT.SHIFT | 'T', SWT.ALT | SWT.F2`. The default value is zero, indicating that the menu item does not have an accelerator.
  Returns:
    the accelerator or 0
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    2.1

- ### setEnabled

  public void setEnabled(boolean enabled)
  Enables the receiver if the argument is `true`, and disables it otherwise. A disabled menu item is typically not selectable from the user interface and draws with an inactive or "grayed" look.
  Parameters:
    `enabled` - the new enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

- ### getEnabled

  public boolean getEnabled()
  Returns `true` if the receiver is enabled, and `false` otherwise. A disabled menu item is typically not selectable from the user interface and draws with an inactive or "grayed" look.
  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    - `isEnabled()`

- ### isEnabled

  public boolean isEnabled()
  Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise. A disabled menu item is typically not selectable from the user interface and draws with an inactive or "grayed" look.
  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    - `getEnabled()`

- ### getSelection

  public boolean getSelection()
  Returns `true` if the receiver is selected, and false otherwise.

  When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked.

  Returns:
    the selection state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

- ### setSelection

  public void setSelection(boolean selection)
  Sets the selection state of the receiver.

  When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked.

  Parameters:
    `selection` - the new selection state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

- ### addSelectionListener

  public void addSelectionListener(SelectionListener listener)
  Adds the listener to the collection of listeners who will be notified when the menu item is selected, by sending it one of the messages defined in the `SelectionListener` interface.

  When `widgetSelected` is called, the stateMask field of the event object is valid. `widgetDefaultSelected` is not called.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    - `SelectionListener`
    - `removeSelectionListener(SelectionListener)`
    - `SelectionEvent`

- ### removeSelectionListener

  public void removeSelectionListener(SelectionListener listener)
  Removes the listener from the collection of listeners who will be notified when the control is selected.
  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    - `SelectionListener`
    - `addSelectionListener(SelectionListener)`

- ### addHelpListener

  public void addHelpListener(HelpListener listener)
  Adds the listener to the collection of listeners who will be notified when the help events are generated for the control, by sending it one of the messages defined in the `HelpListener` interface.
  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    - `HelpListener`
    - `removeHelpListener(HelpListener)`

- ### removeHelpListener

  public void removeHelpListener(HelpListener listener)
  Removes the listener from the collection of listeners who will be notified when the help events are generated for the control.
  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    - `HelpListener`
    - `addHelpListener(HelpListener)`

- ### addArmListener

  public void addArmListener(ArmListener listener)
  Adds the listener to the collection of listeners who will be notified when the arm events are generated for the control, by sending it one of the messages defined in the `ArmListener` interface.
  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    - `ArmListener`
    - `removeArmListener(ArmListener)`

- ### removeArmListener

  public void removeArmListener(ArmListener listener)
  Removes the listener from the collection of listeners who will be notified when the arm events are generated for the control.
  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    - `ArmListener`
    - `addArmListener(ArmListener)`

- ### getAdapter

  public <T> T getAdapter(Class<T> adapter)
  Description copied from class: `Widget`
  Implementation of the `Adaptable` interface.

  IMPORTANT: This method is not part of the RWT public API. It is marked public only so that it can be shared within the packages provided by RWT. It should never be accessed from application code.

  Specified by:
    `getAdapter` in interface `Adaptable`
  Overrides:
    `getAdapter` in class `Widget`
  Parameters:
    `adapter` - the lookup class
  Returns:
    an object that can be cast to the given class or `null` if there is no adapter associated with the given class.